#include "CDebugMessage.h"
#include "common.h"

bool CDebugMessage::AddMessage( std::string sAddMessage )
{
	if( IsWindowVisible( hWndDebug ) == 0 ) return 0;

	if( sMessage.size() != 0 )
	{
		sMessage = sMessage + TEXT("\r\n");
		sMessage = sMessage + sAddMessage;
	}
	else
	{
		sMessage = sMessage + sAddMessage;
	}

	SetWindowText( hWndMessage , sMessage.c_str() );
	SendMessage( hWndMessage, WM_VSCROLL, SB_BOTTOM, 0 );

	return true;
}

CDebugMessage::CDebugMessage()
{
	Initialize( TEXT("Message") );
}

CDebugMessage::CDebugMessage( LPTSTR lpTabString )
{
	Initialize( lpTabString );
}

bool CDebugMessage::Initialize( LPTSTR lpTabString )
{
	int nIndex;
	hWndMessage = CreateWindow(
		TEXT("EDIT") , NULL , 
		WS_CHILD | WS_HSCROLL | WS_VSCROLL |
		ES_AUTOHSCROLL | ES_AUTOVSCROLL |
		ES_LEFT | ES_MULTILINE | ES_READONLY ,
		0 , DW_TAB_HEIGHT , DW_DEFAULT_WIDTH - 8 , DW_DEFAULT_HEIGHT - 28 - DW_TAB_HEIGHT , hWndDebug , (HMENU)1 ,
		GetModuleHandle(NULL) , NULL
	);
	if( hWndMessage == NULL ) return false;
	SendMessage( hWndMessage, WM_SETFONT, (WPARAM)hFont, true );
	nIndex = AddWindow( hWndMessage, lpTabString );
	ChangeTabIndex();
	return true;
}

CDebugMessage::~CDebugMessage()
{
}

CDebugMessage & CDebugMessage::operator << ( char * lpString )
{
	if( lstrcmp( lpString, TEXT("\n")) == 0 || lstrcmp( lpString, TEXT("\r\n")) == 0 )
	{
		OssViewFlush();
	}
	else
	{
		oss << lpString;
	}
	return *this;
}

void CDebugMessage::OssViewFlush( void )
{
	std::ostringstream tmp;
	AddMessage( oss.str().c_str() );
	oss.str( std::string() );
}