
#include "ConvReplace.h"
#include "common.h"

CConvReplace::CConvReplace( const char *lpFilename, const char *lpDefaultData )
{
	CConvReplaceCommon( lpFilename, lpDefaultData );
}

CConvReplace::CConvReplace( const char *lpFilename )
{
	CConvReplaceCommon( lpFilename, "" );
}

void CConvReplace::CConvReplaceCommon( const char *lpFilename, const char *lpDefaultData )
{
	std::string sData;
	std::string sBefore;
	std::string sAfter;
	std::ifstream ifs;

	SetCurrentDirectory( g.lpSoftDir );

	ifs.open( lpFilename );

	bOpenSuccess = !ifs.fail();

	if( !bOpenSuccess )
	{
		std::ofstream ofs( lpFilename );
		if( lstrlen( lpDefaultData ) != 0 )
		{
			ofs << lpDefaultData << std::endl;
			ifs.clear();
			ifs.open( lpFilename );
			bOpenSuccess = !ifs.fail();
		}
	}

	while( !ifs.eof() & bOpenSuccess )
	{
		std::getline( ifs, sData );
		sBefore = sData.substr( 0, sData.find( '=' ) );
		sAfter = sData.substr( sData.find( '=' ) + 1 );
		if( !sBefore.empty() )	// sAfter͋󕶎
		{
			replace( sBefore, "%__EQUAL__%", "=" );
			replace( sAfter, "%__EQUAL__%", "=" );
			vsConvBefore.push_back( sBefore );
			vsConvAfter.push_back( sAfter );
		}
	}
}

void CConvReplace::Replace( std::string &sData )
{
	if( bOpenSuccess == false ) return;

	for( unsigned i = 0 ; i < vsConvBefore.size() ; ++i )
	{
		replace( sData, vsConvBefore[i], vsConvAfter[i] );
	}
}
