#include "WndProcMain.h"

#define FILE_PATH_MAX 256	// _MAX_PATH = 260

static UINT __stdcall ThreadConvertFiles( LPVOID s_lpvParam );

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_CREATE:
		WndProc_WM_CREATE( hWnd, wParam, lParam );
		return 0;

	case WM_COMMAND:
		WndProc_WM_COMMAND( hWnd, wParam, lParam );
		return 0;

	case WM_DROPFILES:
		WndProc_WM_DROPFILES( wParam, lParam );
		return 0;

	case WM_SETCURSOR:
		WndProc_WM_SETCURSOR( hWnd, wParam, lParam );
		break;

	case WM_MENUSELECT:
		WndProc_WM_MENUSELECT( hWnd, wParam, lParam );
		return 0;

	case WM_DESTROY:
		g.ini->IniSave( g.lpSoftDir );
		DragAcceptFiles( hWnd, false );
		PostQuitMessage( 0 );
		return 0;

	} // switch( uMsg )
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

static int SetClientRect( HWND hWnd, int nWidth, int nHeight )
{
	RECT Rect, Rect2;

	GetWindowRect( hWnd, &Rect );
	GetClientRect( hWnd, &Rect2 );
	nWidth = ( Rect.right - Rect.left ) - Rect2.right + nWidth;
	nHeight = ( Rect.bottom - Rect.top ) - Rect2.bottom + nHeight;

	Rect2.top = 0;
	Rect2.left = 0;
	Rect2.right = 80 * 4;
	Rect2.bottom = 80;
	AdjustWindowRect( &Rect2, WS_OVERLAPPEDWINDOW, true );

	MoveWindow( hWnd, Rect.left, Rect.top, nWidth, nHeight, true ); 

	return 0;
}

static int WndProc_WM_CREATE( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	HWND hWndOpenBtn, hWndRestoreBtn, hWndHelpBtn, hWndExitBtn;
	HWND hWndStatusBar;
	HINSTANCE hInstance;
	RECT Rect;
	int nStatusBarHeight;

	// 
	hInstance = ((CREATESTRUCT *)lParam)->hInstance;
	g.hInstance = hInstance;
	g.hMenu = GetMenu( hWnd );
	DragAcceptFiles( hWnd, true );
	InitCommonControls();
	std::vector<std::string> vsCommandLine = GetCommandLineArgs();
	bool bOptionShow = vsCommandLine.empty();	// R}hCIvVw肳Ăꍇ̓ftHgŃEBhE\I
	if( CheckCommandLineOption( vsCommandLine, "/show" ) )
	{
		bOptionShow = true;
	}
	bool bOptionExit = CheckCommandLineOption( vsCommandLine, "/exit" );
	if( !bOptionShow && !bOptionExit )
	{
		vsCommandLine.push_back( "/exit" );	// EBhE\̏ꍇ͏ItOŒǉ
	}

	// GUI
	// J{^
	hWndOpenBtn	= CreateWindow(
		"BUTTON", "J(&O)...",
		WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_PUSHBUTTON | BS_FLAT ,
		0, 0, 80, 80,
		hWnd, (HMENU)ID_BUTTON_OPEN, hInstance, NULL
	);

	// ɖ߂{^
	hWndRestoreBtn	= CreateWindow(
		"BUTTON", "ɖ߂(&U)",
		WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_PUSHBUTTON | BS_FLAT,
		80, 0, 80, 80,
		hWnd, (HMENU)ID_BUTTON_RESTORE, hInstance, NULL
	);

	// wv{^
	hWndHelpBtn	= CreateWindow(
		"BUTTON", "wv(F1)...",
		WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_PUSHBUTTON | BS_FLAT,
		160, 0, 80, 80,
		hWnd, (HMENU)ID_BUTTON_HELP, hInstance, NULL
	);

	// I{^
	hWndExitBtn	= CreateWindow(
		"BUTTON", "I(&X)",
		WS_CHILD | WS_TABSTOP | WS_VISIBLE | BS_PUSHBUTTON | BS_FLAT,
		240, 0, 80, 80,
		hWnd, (HMENU)ID_BUTTON_EXIT, hInstance, NULL
	);

	// Xe[^Xo[
	hWndStatusBar = CreateStatusWindow(
		WS_CHILD | WS_VISIBLE | CCS_BOTTOM, NULL, hWnd, 1
	);
	GetWindowRect( hWndStatusBar, &Rect );
	nStatusBarHeight = Rect.bottom - Rect.top;

	g.hWndStatusBar = hWndStatusBar;
	g.hWndOpenBtn = hWndOpenBtn;
	g.hWndRestoreBtn = hWndRestoreBtn;
	g.hWndHelpBtn = hWndHelpBtn;
	g.hWndExitBtn = hWndExitBtn;

	// EBhẼTCY␳
	SetClientRect( hWnd, 80 * 4, 80 + nStatusBarHeight );
	GetWindowRect( hWndStatusBar, &Rect );
	MoveWindow( hWndStatusBar, 0, 0, 0, 0, true ); 

	// tHg
	SetDefaultGUIFont( hWndOpenBtn );
	SetDefaultGUIFont( hWndRestoreBtn );
	SetDefaultGUIFont( hWndHelpBtn );
	SetDefaultGUIFont( hWndExitBtn );

	// j[o[̏Ԑݒ
	if( bOptionShow )
	{
		SetWindowPosition( debug.GetDebugWindowHandle(), g.ini->nInfoWindowLeft, g.ini->nInfoWindowTop );
		SetWindowSize( debug.GetDebugWindowHandle(), g.ini->nInfoWindowWidth, g.ini->nInfoWindowHeight );
		if( g.ini->bInfoWindowShow )
		{
			CheckMenuItem( g.hMenu, ID_MENU_INFO, MF_CHECKED );
			ShowWindow( debug.GetDebugWindowHandle(), SW_SHOW );
			SetWindowZOrder( hWnd, HWND_TOP );
		}
	}

	switch( g.ini->nConvMode )
	{
	case 1:
		CheckMenuItem( g.hMenu, ID_MENU_CONV_AUTO, MF_CHECKED );
		break;
	case 2:
		CheckMenuItem( g.hMenu, ID_MENU_CONV_CONV, MF_CHECKED );
		break;
	case 3:
		CheckMenuItem( g.hMenu, ID_MENU_CONV_RESTORE, MF_CHECKED );
		break;
	}

	switch( g.ini->nConvOption )
	{
	case 1:
		CheckMenuItem( g.hMenu, ID_MENU_CONV_ROMAN, MF_CHECKED );
		break;
	case 2:
		CheckMenuItem( g.hMenu, ID_MENU_CONV_KATAKANA, MF_CHECKED );
		break;
	}

	if( g.ini->bConvTag )
	{
		CheckMenuItem( g.hMenu, ID_MENU_CONV_TAG, MF_CHECKED );
	}
	else
	{
		EnableMenuItem( g.hMenu, ID_MENU_CONV_TAG_AGREE, MF_GRAYED );
	}

	if( g.ini->bConvTagAgree )
	{
		CheckMenuItem( g.hMenu, ID_MENU_CONV_TAG_AGREE, MF_CHECKED );
	}

	if( g.ini->bDispConvBeforeDialog )
	{
		CheckMenuItem( g.hMenu, ID_MENU_DLG_CONV_BEFORE, MF_CHECKED );
	}

	if( g.ini->bDispRestBeforeDialog )
	{
		CheckMenuItem( g.hMenu, ID_MENU_DLG_REST_BEFORE, MF_CHECKED );
	}

	if( g.ini->bDispConvRestAfterDialog )
	{
		CheckMenuItem( g.hMenu, ID_MENU_DLG_AFTER, MF_CHECKED );
	}

	if( g.ini->bWndTopMost )
	{
		CheckMenuItem( g.hMenu, ID_MENU_WND_TOPMOST, MF_CHECKED );
	}

	// ϐVݒ肵ꍇ͍ċN
	// j[o[̐ݒ肪ĂsȂΊԈݒ肪ۑĂ܂̂Őݒ肵s邱
	if( KakasiSetEnvironmentDictPath() )
	{
		g.nExitCode = EXIT_CODE_SET_ENVIRONMENT;
		std::string sParam;
		for( unsigned i = 0 ; i < vsCommandLine.size() ; ++i )
		{
			if( !sParam.empty() ){ sParam += " "; }
			sParam += "\"" + vsCommandLine[i] + "\"";
		}
		ShellExecute( NULL, "open", GetExePath().c_str(), sParam.c_str(), NULL, SW_SHOWNORMAL );
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		return 0;
	}

	// GUI쐬㏉
	if( bOptionShow )
	{
		ShowWindow( hWnd, SW_SHOW );
	}
	g.log->EnableRestoreBtnMenu();
	debug << g.lpSoftName << " Ver." << g.lpVer >> 0;
	if( g.ini->bWndTopMost )
	{
		SetWindowZOrder( hWnd, HWND_TOPMOST );
	}

	// R}hC̎w
	if( !vsCommandLine.empty() )
	{
		static std::vector<std::string> vsConvertFile = vsCommandLine;
		UINT dwThreadId;
		g.hThreadConvert = (HANDLE)_beginthreadex( NULL, 0, ThreadConvertFiles, (LPVOID)&vsConvertFile, 0, &dwThreadId );		
	}

	return 0;
}

static int WndProc_WM_COMMAND( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	int nCommandID = LOWORD(wParam);

	// EBhEs
	switch( nCommandID )
	{

	case ID_MENU_INFO:
	case ID_ACCEL_INFO:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_INFO );
		if( GetMenuItemCheckState( g.hMenu, ID_MENU_INFO ) == true )
		{
			ShowWindow( debug.GetDebugWindowHandle(), SW_SHOW );
			ShowWindow( hWnd, SW_HIDE );
			ShowWindow( hWnd, SW_SHOW );
		}
		else
		{
			ShowWindow( debug.GetDebugWindowHandle(), SW_HIDE );
		}
		break;
	}

	} // switch( LOWORD(wParam) ) EBhE

	// EBhEĂ炱ȍ~̃bZ[W͏Ȃ
	if( IsWindowEnabled( hWnd ) == 0 ) return 0;

	// EBhEL̂ݎs
	switch( nCommandID )
	{

	case ID_BUTTON_OPEN:
	case ID_MENU_OPEN:
	case ID_ACCEL_OPEN:
	{

		OPENFILENAME ofn;
		lstrcpy( g.lpBuf, "" );

		ZeroMemory( &ofn, sizeof( OPENFILENAME ) );
		ofn.lStructSize = sizeof( OPENFILENAME );
		ofn.hwndOwner = hWnd;
		ofn.lpstrFilter = "All Files(*.*)\0*.*\0\0";
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = g.lpBuf;
		ofn.nMaxFile = CGLOBALSTRUCT_BUFFER_SIZE;
		ofn.lpstrTitle = "ϊt@CIĂB";
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY/* | OFN_ALLOWMULTISELECT */| OFN_EXPLORER;

		if( GetOpenFileName( &ofn ) )
		{
			if( !GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_CONV_BEFORE ) || IDYES == MessageBox( g.hWndMain, "It@Cϊ܂H", g.lpSoftName, MB_APPDEF_3BUTTON ) )
			{
				ConvertFileBefore();
				ConvertFileAfter( ConvertFile( g.lpBuf ) );
			}
		}

		break;
	}

	case ID_BUTTON_EXIT:
	case ID_MENU_EXIT:
	case ID_ACCEL_EXIT:
	{
		PostMessage( hWnd, WM_DESTROY, 0, 0 );
		break;
	}

	case ID_BUTTON_HELP:
	case ID_MENU_HELP:
	case ID_ACCEL_HELP:
	{
		if( IDYES == MessageBox( g.hWndMain, "wvt@CJ܂H", g.lpSoftName, MB_APPDEF_3BUTTON ) )
		{
			SetCurrentDirectory( g.lpSoftDir );
			ShellExecute( NULL, "open", "help/help.html", NULL, NULL, SW_SHOWNORMAL );
		}
		break;
	}

	case ID_MENU_WEB:
	{
		ShellExecute( NULL, NULL, "http://eigoukaiki.s101.xrea.com/", NULL, NULL, SW_SHOWNORMAL );
		break;
	}

	case ID_MENU_MAIL:
	{
		if( IDYES == MessageBox( g.hWndMain, "[\tgN܂H", g.lpSoftName, MB_APPDEF_3BUTTON ) )
		{
			ShellExecute( NULL, NULL, "mailto:eigoukaiki.rinne@gmail.com", NULL, NULL, SW_SHOWNORMAL );
		}
		break;
	}
	case ID_MENU_ABOUT:
	{
		std::string sBuf;

		sBuf += "\n";
		sBuf += g.lpSoftName;
		sBuf += "  Ver.";
		sBuf += g.lpVer;
		sBuf += "\n\n";
		sBuf +="Weby[W F http://eigoukaiki.s101.xrea.com/\n";
		sBuf +="E[ F eigoukaiki.rinne@gmail.com\n";
		sBuf += "\n";
		sBuf += "stH_ F ";
		sBuf += g.lpSoftDir;
		sBuf += "\n";
		sBuf += "gpDLL F kakasi.dll , mp3infp.dll";

		sBuf += "\n\n";
		MessageBox( g.hWndMain, sBuf.c_str(), g.lpSoftName, MB_OK | MB_SETFOREGROUND | MB_TOPMOST );
		break;
	}

	case ID_BUTTON_RESTORE:
	case ID_MENU_RESTORE:
	case ID_ACCEL_RESTORE:
	{
		std::string sBuf;
		std::string sDate;

		if( g.log->IsRestoreData() == false ) break;

		if( g.log->GetRestoreDataInfo( sDate ) == 0 ) break;
		sBuf =  "O̕ϊɖ߂܂H\n\n";
		sBuf += "ϊF";
		sBuf += sDate;

		if( !GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_REST_BEFORE ) || IDYES == MessageBox( g.hWndMain, sBuf.c_str(), g.lpSoftName, MB_APPDEF_3BUTTON ) )
		{
			g.log->RestoreData();
		}
		break;
	}

	case ID_MENU_LOG_OPEN:
	{
		g.log->FileOpen();
		break;
	}

	case ID_MENU_LOG_DELETE:
	{
		if( IDYES == MessageBox( g.hWndMain, "Ot@C폜ƁAȑOϊt@C̕ύX͌ɖ߂ȂȂ܂B\nt@C폜܂H", g.lpSoftName, MB_APPDEF_3BUTTON ) )
		{
			if( g.log->Delete() == true ) g.log->EnableRestoreBtnMenu();
		}
		break;
	}

	case ID_MENU_CONV_AUTO:
	case ID_MENU_CONV_CONV:
	case ID_MENU_CONV_RESTORE:
	{
		CheckMenuItem( g.hMenu, ID_MENU_CONV_AUTO, MF_UNCHECKED );
		CheckMenuItem( g.hMenu, ID_MENU_CONV_CONV, MF_UNCHECKED );
		CheckMenuItem( g.hMenu, ID_MENU_CONV_RESTORE, MF_UNCHECKED );
		CheckMenuItem( g.hMenu, LOWORD(wParam), MF_CHECKED );	
		break;
	}

	case ID_MENU_CONV_ROMAN:
	case ID_MENU_CONV_KATAKANA:
	{
		CheckMenuItem( g.hMenu, ID_MENU_CONV_ROMAN, MF_UNCHECKED );
		CheckMenuItem( g.hMenu, ID_MENU_CONV_KATAKANA, MF_UNCHECKED );
		CheckMenuItem( g.hMenu, nCommandID, MF_CHECKED );	
		break;
	}

	case ID_MENU_CONV_TAG:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_CONV_TAG );
		if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_TAG ) == true )
		{
			EnableMenuItem( g.hMenu, ID_MENU_CONV_TAG_AGREE, MF_ENABLED );
		}
		else
		{
			EnableMenuItem( g.hMenu, ID_MENU_CONV_TAG_AGREE, MF_GRAYED );
		}
		break;
	}

	case ID_MENU_CONV_TAG_AGREE:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_CONV_TAG_AGREE );
		break;
	}

	case ID_MENU_CONV_BEFORE:
	case ID_MENU_CONV_AFTER:
	case ID_MENU_CONV_FILE:
	{
		SetCurrentDirectory( g.lpSoftDir );
		MessageBox( g.hWndMain, "ݒ̕ύXe̓\tg̍ċN㔽f܂B", g.lpSoftName, MB_APPDEF_OK );
		switch( nCommandID )
		{
		case ID_MENU_CONV_BEFORE:
			ShellExecute( NULL, "open", "ConvBefore.txt", NULL, NULL, SW_SHOWNORMAL );
			break;
		case ID_MENU_CONV_AFTER:
			ShellExecute( NULL, "open", "ConvAfter.txt", NULL, NULL, SW_SHOWNORMAL );
			break;
		case ID_MENU_CONV_FILE:
			ShellExecute( NULL, "open", "ConvFilename.txt", NULL, NULL, SW_SHOWNORMAL );
			break;
		}
		break;
	}

	case ID_MENU_DLG_CONV_BEFORE:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_DLG_CONV_BEFORE );
		break;
	}

	case ID_MENU_DLG_REST_BEFORE:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_DLG_REST_BEFORE );
		break;
	}

	case ID_MENU_DLG_AFTER:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_DLG_AFTER );
		break;
	}

	case ID_MENU_WND_TOPMOST:
	{
		ReplaceCheckMenu( g.hMenu, ID_MENU_WND_TOPMOST );
		if( GetMenuItemCheckState( g.hMenu, ID_MENU_WND_TOPMOST ) == true )
		{
			SetWindowZOrder( g.hWndMain, HWND_TOPMOST );
		}
		else
		{
			SetWindowZOrder( g.hWndMain, HWND_NOTOPMOST );
		}
		break;
	}

	} // switch( LOWORD(wParam) )


	return 0;
}


static int SetStatusBarText( const char *lpSetText )
{
	char lpBuf[128];
	GetWindowText( g.hWndStatusBar, lpBuf, 126 );
	if( lstrcmp( lpBuf, lpSetText ) != NULL )
	{
		SetWindowText( g.hWndStatusBar, lpSetText );
		return 0;
	}
	else
	{
		return 1;
	}
}

int SetStatusBarProgress( int nNow, int nMax )
{
	// nMax0w肷""\
	static char lpBuf[64];

	if( nMax == 0 )
	{
		return SetWindowText( g.hWndStatusBar, "" );
	}
	wsprintf( lpBuf, "( %d / %d )...", nNow, nMax );
	return SetWindowText( g.hWndStatusBar, lpBuf );
}

static UINT __stdcall ThreadConvertFiles( LPVOID s_lpvParam )
{
	int nNewFlag = 0;
	std::string sMessageBoxString = "t@CEtH_ϊ܂H";
	std::vector<std::string> &vsConvertFiles = *( reinterpret_cast<std::vector<std::string> *>( s_lpvParam ) );

	EnableWindow( g.hWndMain, false );

	if( vsConvertFiles.size() > 1 )
	{
		sMessageBoxString = "" + sMessageBoxString;
	}

	if( !GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_CONV_BEFORE ) || IDYES == MessageBox( g.hWndMain, sMessageBoxString.c_str(), g.lpSoftName, MB_APPDEF_3BUTTON ) )
	{
		ConvertFileBefore();	// O
		// [v
		for( unsigned i = 0 ; i < vsConvertFiles.size() ; ++i )
		{
			if( GetAsyncKeyState( VK_ESCAPE ) < 0 )
			{
				if( IDYES == MessageBox( g.hWndMain, "rI܂H", g.lpSoftName, MB_APPDEF ) ) break;
			}

			SetStatusBarProgress( i+1, static_cast<int>( vsConvertFiles.size() ) );

			// ϊ
			if( PathFileExists( vsConvertFiles[i].c_str() ) )
			{
				int nRet = ConvertFile( vsConvertFiles[i] );
				if( nRet == 1 || nRet == -2 )	// XVꍇ
				{
					nNewFlag = 1;
				}
			}
		}
		ConvertFileAfter( nNewFlag );	// ㏈
	}

	EnableWindow( g.hWndMain, true );

	// ItO`FbN
	if( CheckCommandLineOption( vsConvertFiles, "/exit" ) )
	{
		PostMessage( g.hWndMain, WM_CLOSE, 0, 0 );
	}

	return 0;
}

static int WndProc_WM_DROPFILES( WPARAM wParam, LPARAM lParam )
{
	HDROP hDrop = (HDROP)wParam;
	int nDropFiles = DragQueryFile( hDrop, -1, NULL, 0 );
	static std::vector<std::string> vsConvertFiles;

	if( nDropFiles > 0 )
	{
		vsConvertFiles.resize( nDropFiles );
		for( int i = 0 ; i < nDropFiles ; ++i )
		{
			DragQueryFile( hDrop, i, g.lpBuf, g.nBufSize );
			vsConvertFiles[i] = g.lpBuf;
		}
	}
	DragFinish( hDrop );

	if( !vsConvertFiles.empty() )
	{
		UINT dwThreadId;
		g.hThreadConvert = (HANDLE)_beginthreadex( NULL, 0, ThreadConvertFiles, (LPVOID)&vsConvertFiles, 0, &dwThreadId );
	}

	return 0;
}

static int WndProc_WM_SETCURSOR( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	HWND hWndPoint = (HWND)wParam;
	if( hWndPoint == g.hWndOpenBtn )
	{
		SetStatusBarText( "ϊt@CI܂ (hbO&hbv)" );
	}
	else if( hWndPoint == g.hWndRestoreBtn )
	{
		SetStatusBarText( "O̕ϊɖ߂܂" );
	}
	else if( hWndPoint == g.hWndHelpBtn )
	{
		SetStatusBarText( "wvt@CJ܂" );
	}
	else if( hWndPoint == g.hWndExitBtn )
	{
		SetStatusBarText( "\tgI܂" );
	}
	else {
		SetStatusBarText( "" );
	}
	return 0;
}

static int WndProc_WM_MENUSELECT( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	static UINT uIDS[] = {
		NULL, 0,
		NULL, ID_MENU_OPEN,
		NULL, ID_MENU_EXIT,
		NULL, ID_MENU_HELP,
		NULL, ID_MENU_WEB,
		NULL, ID_MENU_MAIL,
		NULL, ID_MENU_ABOUT,
	};
	MenuHelp( WM_MENUSELECT, wParam, lParam ,GetMenu( hWnd ), g.hInstance , g.hWndStatusBar , uIDS );
	return 0;
}


static void ConvertFileBefore( void )
{
	g.log->EnableRestoreBtnMenu();
	g.log->AddLogIndex();
}

static void ConvertFileAfter( int nNewFlag )
{
	SetStatusBarProgress( 0, 0 );
	if( nNewFlag == 1 )
	{
		g.log->DeleteOldData();
		g.log->EnableRestoreBtnMenu();
	}
	else
	{
		g.log->SubLogIndex();
	}

	if( GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_AFTER ) )
	{
		MessageBox( g.hWndMain, "܂B", g.lpSoftName, MB_APPDEF_OK );
	}
}

static int ConvertFile( std::string sFilePath )
{
	std::string sFileName, sFileDir;

	GetFileName( sFilePath, sFileName );
	GetFileDir( sFilePath, sFileDir );

	return ConvertFile( sFileName, sFileDir );
}

static int ConvertFile( std::string sFileName, std::string sFileDir )
{	// // ߂lF 0=XVA1=XVLA-1=~A-2=~(XVL)

	std::string sFileNameRoman;
	int nNewTag = 0;
	int nNewName = 0;
	int nRet;
	int nMode;

	debug >> 0;
	debug << "[ϊ]" << sFileDir << sFileName << "" >> 0;

	// ^Oϊ
	while(1)
	{
		nNewTag = ConvertTag( sFileDir + sFileName );
		if( nNewTag != -1 )
		{
			break;
		}
		else
		{
			nRet = ConvertFileError( sFileDir + sFileName );
			if( nRet == IDIGNORE )
			{
				nNewTag = 0;
				break;
			}
			else if( nRet == IDABORT )
			{
				return -1;
			}
		}
	}

	// [}ϊ
	sFileNameRoman = KakasiWrap( const_cast<char*>(sFileName.c_str()), sFileDir + sFileName , KAKASI_FLAG_FILENAME, &nMode );

	// l[
	while(1)
	{
		nNewName = ReNameFile( sFileName, sFileNameRoman, sFileDir, nMode );
		if( nNewName != -1 )
		{
			break;
		}
		else
		{
			nRet = ConvertFileError( sFileDir + sFileName );
			if( nRet == IDIGNORE )
			{
				nNewName = 0;
				break;
			}
			else if( nRet == IDABORT )
			{
				if( nNewTag ) return -2; else ; return -1;
			}
		}
	}

	if( nNewTag | nNewName ) return 1; else ; return 0;
}



static int ConvertFileError( std::string sWriteFilePath, std::string sAddData )
{
	std::string sBuf;
	sBuf = "݂Ɏs܂B\n";
	sBuf += "pXF";
	sBuf += sWriteFilePath;
	sBuf += "\n";
	if( !sAddData.empty() )
	{
		sBuf += sAddData;
		sBuf += "\n";
	}
	sBuf += "\nt@CEtH_݂ȂAgpłȂA܂͓ǂݎpɂȂĂȂmFĂB";
	return MessageBox( g.hWndMain, sBuf.c_str(), g.lpSoftName, MB_ABORTRETRYIGNORE | MB_SETFOREGROUND | MB_TOPMOST );
}

static int ConvertTagWriteLogBuffer( int nFlag, std::string sFilePath, std::string sType, std::string sData )
{
	static std::vector<std::string> vsFilePath;
	static std::vector<std::string> vsType;
	static std::vector<std::string> vsData;

	// obt@ɒǉ
	if( nFlag == 0 )
	{
		vsFilePath.push_back( sFilePath );
		vsType.push_back( sType );
		vsData.push_back( sData );
	}
	// obt@
	else if( nFlag == 1 )
	{
		for( unsigned i = 0 ; i < vsFilePath.size() ; ++i )
		{
			g.log->WriteLogData( vsFilePath[i], vsType[i], vsData[i] );
		}
		vsFilePath.clear();
		vsType.clear();
		vsData.clear();
	}
	// obt@NA
	else
	{
		vsFilePath.clear();
		vsType.clear();
		vsData.clear();
	}

	return 0;
}

static int mp3infp_ValueRoman( const char *lpValueName, std::string sFilePath )
{
	/*
	^Oϊ
	lpValueName : ^O̎
	return : =1AsEύX=0
	//*/

	std::string sTagDefault;
	std::string sTagRoman;
	char *lpBuf = NULL;
	
	static LPMP3INFP_GETVALUE mp3infp_GetValue = (LPMP3INFP_GETVALUE) GetProcAddress( g.hMp3infpDll, "mp3infp_GetValue" );
	static LPMP3INFP_SETVALUE mp3infp_SetValue = (LPMP3INFP_SETVALUE) GetProcAddress( g.hMp3infpDll, "mp3infp_SetValue" );

	mp3infp_GetValue( lpValueName, &lpBuf);
	if( lstrlen( lpBuf ) == 0 ) return 0;
	sTagDefault = lpBuf;

	sTagRoman = KakasiWrap( lpBuf, sFilePath );
	if( lstrcmp( lpBuf, sTagRoman.c_str() ) == NULL ) return 0;

	debug << "\t^OF(" << lpValueName << ")" << lpBuf << " -> " << sTagRoman >> 0;
	if( mp3infp_SetValue( lpValueName, sTagRoman.c_str()) != ERROR_SUCCESS )
	{
		debug << "[G[]mp3infp_SetValue()" >> 0;
		return 0;
	}
	else
	{
		ConvertTagWriteLogBuffer( 0, sFilePath, lpValueName, lpBuf );
		// f[^Ő؂l߂ĂꍇɁȀf[^x[Xɓo^
		mp3infp_GetValue( lpValueName, &lpBuf);
		if( sTagRoman != std::string( lpBuf ) )
		{
			ConvDatabase.AddData( sTagDefault, lpBuf, sFilePath, KAKASI_FLAG_DEFAULT );
		}
		return 1;
	}
}

static int mp3infp_ValueRomanCommon( std::string sFilePath )
{	// ^Oǂݏo/݂̋ʕ

	int nFlagNew = 0;
	// ^Cg/A[eBXg/Ao
	nFlagNew += mp3infp_ValueRoman( "INAM", sFilePath );
	nFlagNew += mp3infp_ValueRoman( "IART", sFilePath );
	nFlagNew += mp3infp_ValueRoman( "IPRD", sFilePath );
	// Rg/쐬/W
	nFlagNew += mp3infp_ValueRoman( "ICMT", sFilePath );
	nFlagNew += mp3infp_ValueRoman( "ICRD", sFilePath );
	nFlagNew += mp3infp_ValueRoman( "IGNR", sFilePath );

	return nFlagNew;
}


static int ConvertTag( std::string sFilePath )
{	// return : XV=1ȏ(XV)

	DWORD dwFileType;
	int nFlagNew = 0;
	static LPMP3INFP_LOAD mp3infp_Load = (LPMP3INFP_LOAD) GetProcAddress( g.hMp3infpDll, "mp3infp_Load");
	static LPMP3INFP_SAVE mp3infp_Save = (LPMP3INFP_SAVE) GetProcAddress( g.hMp3infpDll, "mp3infp_Save" );
	static LPMP3INFP_GETTYPE mp3infp_GetType = (LPMP3INFP_GETTYPE) GetProcAddress( g.hMp3infpDll, "mp3infp_GetType" );

	if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_TAG ) == false )
	{
		return 0;
	}

	if( g.hMp3infpDll == NULL )
	{
		return 0;
	}

	if( mp3infp_Load( g.hWndMain, sFilePath.c_str() ) != ERROR_SUCCESS )
	{
		debug << "[G[]^O̓ǂݏo mp3infp_Load() s" >> 0;
		return 0;
	}

	// t@C^CvƂɏ
	dwFileType = mp3infp_GetType();
	switch( dwFileType )
	{
	case MP3INFP_FILE_MP3 :
		// ^Cg
		nFlagNew += mp3infp_ValueRoman( "INAM_v1", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "INAM_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "INAM_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "INAM_APE", sFilePath );
		// A[eBXg
		nFlagNew += mp3infp_ValueRoman( "IART_v1", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IART_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IART_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IART_APE", sFilePath );
		// Ao
		nFlagNew += mp3infp_ValueRoman( "IPRD_v1", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IPRD_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IPRD_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IPRD_APE", sFilePath );
		// Rg
		nFlagNew += mp3infp_ValueRoman( "ICMT_v1", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICMT_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICMT_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICMT_APE", sFilePath );
		// W
		nFlagNew += mp3infp_ValueRoman( "IGNR_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IGNR_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IGNR_APE", sFilePath );
		// 쌠(ID3v2/RiffSIF)
		nFlagNew += mp3infp_ValueRoman( "ICOP_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICOP_rmp", sFilePath );
		//\tgEFA/GR[_(ID3v2/RiffSIF)
		nFlagNew += mp3infp_ValueRoman( "ISFT_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ISFT_rmp", sFilePath );
		// /Orig.A[eBXg/GR[hl(ID3v2)
		nFlagNew += mp3infp_ValueRoman( "COMP_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "OART_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ENC2_v2", sFilePath );
		// \[X/GWjA(RiffSIF)
		nFlagNew += mp3infp_ValueRoman( "ISRC_rmp", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IENG_rmp", sFilePath );
		// gbNԍ
		nFlagNew += mp3infp_ValueRoman( "TRACK_v2", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "TRACK_APE", sFilePath );

		break;

	case MP3INFP_FILE_WAV:
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// 쌠/\tgEFA/\[X/GWjA
		nFlagNew += mp3infp_ValueRoman( "ICOP", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ISFT", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ISRC", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IENG", sFilePath );

		break;

	case MP3INFP_FILE_AVI:
		// iAôݗ]Ɏsj
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// 쌠/\tgEFA/\[X/GWjA
		nFlagNew += mp3infp_ValueRoman( "ICOP", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ISFT", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ISRC", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IENG", sFilePath );

		break;

	case MP3INFP_FILE_VQF:
		// ^Cg/A[eBXg/Rg
		nFlagNew += mp3infp_ValueRoman( "INAM", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "IART", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICMT", sFilePath );
		// 쌠/ۑ
		nFlagNew += mp3infp_ValueRoman( "ICOP", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "FILE", sFilePath );

		break;

	case MP3INFP_FILE_WMA:
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// gbNԍ/쌠
		nFlagNew += mp3infp_ValueRoman( "TRACK", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "ICOP", sFilePath );

		break;

	case MP3INFP_FILE_OGG:
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// gbNԍ
		nFlagNew += mp3infp_ValueRoman( "TRACK", sFilePath );

		break;

	case MP3INFP_FILE_APE:
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// gbNԍ
		nFlagNew += mp3infp_ValueRoman( "TRACK", sFilePath );

		break;

	case MP3INFP_FILE_MP4:
		nFlagNew += mp3infp_ValueRomanCommon( sFilePath );

		// O[v//c[
		nFlagNew += mp3infp_ValueRoman( "IGRP", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "COMPOSER", sFilePath );
		nFlagNew += mp3infp_ValueRoman( "TOOL", sFilePath );

		break;

	default:
		nFlagNew = 0;

		break;
	}

	if( nFlagNew )
	{
		if( mp3infp_Save( sFilePath.c_str() ) != ERROR_SUCCESS )
		{
			ConvertTagWriteLogBuffer( -1, "", "", "" );		// obt@NA
			debug << "[G[]^O̕ۑ mp3infp_Save() s" >> 0;
			nFlagNew = -1;
		}
		else
		{
			ConvertTagWriteLogBuffer( 1, "", "", "" );		// obt@
		}
	}

	return nFlagNew;
}



static bool FileNameReduce( std::string &sFilename, std::string &sFileDir, int nSize )
{	// t@Cw̃TCYŐ؂l߂ return : ؂l߂ true, ύX false

	std::string sFilenameDefault = sFilename;
	std::string sFilePath;
	std::string::size_type nPosExtension;

	sFilePath = sFileDir + sFilename;

	if( (int)sFilePath.size() <= nSize ) return false;

	nPosExtension = sFilePath.find_last_of( '.' );
	if( nPosExtension != std::string::npos )
	{
		// gqt@C؂l߂
		std::string sExtension;
		std::string sFilePath_NoExt;
		sExtension = sFilePath.substr( nPosExtension, sFilePath.size() - nPosExtension + 1 );
		sFilePath_NoExt = sFilePath.substr( 0, sFilePath.size() - sExtension.size() );
		sFilePath_NoExt.resize( nSize - sExtension.size() );
		sFilePath = sFilePath_NoExt + sExtension;
	}
	else
	{
		// gq݂Ȃꍇ̂܂ܐ؂l߂
		sFilePath.resize( nSize );
	}

	GetFileName( sFilePath, sFilename );
	if( sFilenameDefault != sFilename )
	{
		return true;
	}
	else
	{
		return false;
	}
}


static int ReNameFile( std::string sFileName, std::string sFileNameRoman, std::string sFileDir, int nMode )
{	// l[

	int i;
	bool bIsChanged = false;	// t@CXɕύXۂBt@C̖(%d)t
	char lpBuf[8];
	int nNewFlag = 0;
	std::string sFileNameRomanOrg;
	std::string::size_type nPosExtension;

	// ύXȂreturn
	if( !lstrcmp( sFileName.c_str(), sFileNameRoman.c_str() ) )
	{
		return nNewFlag;
	}

	SetCurrentDirectory( sFileDir.c_str() );

	sFileNameRomanOrg = sFileNameRoman;
	for( i = 2 ; true ; ++i )
	{
		// ŗL΃t@C؂l߂͎sȂ
		if( nMode != KAKASI_MODE_REST )
		{
			if( FileNameReduce( sFileNameRoman, sFileDir, FILE_PATH_MAX ) )
			{
				ConvDatabase.AddData( sFileName, sFileNameRoman, sFileDir+sFileName, KAKASI_FLAG_FILENAME ); // t@C؂l߂ꍇf[^x[Xɓo^
			}
		}

		if( !rename( sFileName.c_str(), sFileNameRoman.c_str() ) )
		{
			g.log->WriteLogData( sFileDir+sFileName, "FILE", sFileNameRoman );
			if( bIsChanged && nMode != KAKASI_MODE_REST )
			{
				ConvDatabase.AddData( sFileName, sFileNameRoman, sFileDir+sFileName, KAKASI_FLAG_FILENAME ); // t@C̖(%d)tꍇf[^x[Xɓo^
			}
			debug << "\tOF" << sFileName << " -> " << sFileNameRoman >> 0;
			nNewFlag = 1;

			break;
		}
		else
		{
			// l[̃t@CdĂ܂ꍇɃt@C̖(%d)t
			bIsChanged = true;
			debug << sFileNameRoman >> 0;
			if( PathFileExists( ( sFileDir + sFileNameRoman ).c_str() ) )
			{
				sFileNameRoman = sFileNameRomanOrg;
				wsprintf( lpBuf, "(%d)", i );
				FileNameReduce( sFileNameRoman, sFileDir, FILE_PATH_MAX - (int)lstrlen( lpBuf ) );
				nPosExtension = sFileNameRoman.find_last_of( '.' );
				if( nPosExtension != std::string::npos )
				{
					sFileNameRoman.insert( nPosExtension, lpBuf );
				}
				else
				{
					sFileNameRoman += lpBuf;
				}
			}
			else
			{
				debug << "[G[]l[s : " << sFileNameRoman >> 0;
				nNewFlag = -1;
				break;
			}
		}
	}

	return nNewFlag;
}

