
#include "common.h"
#include "WndProcMain.h"

CDebugMessage debug("bZ[W");
CGlobalStruct g;
//--------------------------------------------------------------------------
// CGlobalStruct
//--------------------------------------------------------------------------
// RXgN^
CGlobalStruct::CGlobalStruct()
{	
	lpSoftName = "Ganmigi";
	lpVer = "1.30";
	nVer = 130;
	nTmp = 0;
	nExitCode = EXIT_CODE_NORMAL;
	nBufSize = CGLOBALSTRUCT_BUFFER_SIZE;
	hThreadConvert = 0;
	hThreadRestore = 0;

	// JgfBNg̋L
	static std::vector<char> vcSoftDir( GetExeDir().size() + 1 );
	lstrcpy( &vcSoftDir[0], GetExeDir().c_str() );
	lpSoftDir = &vcSoftDir[0];
	SetCurrentDirectory( GetExePath().c_str() );

	// iniIuWFNg(lpSoftDir)
	static CGlobalStruct_ini obj_int;
	ini = &obj_int;

	// logIuWFNg(lpSoftDir)
	static CGlobalStruct_log obj_log;
	log = &obj_log;

	// INIǂݍ
	ini->IniLoad( lpSoftDir );

	// mp3infp.dll̓ǂݍ
	hMp3infpDll = LoadLibrary("mp3infp.dll");
	if( hMp3infpDll )
	{
		DWORD dwVer;
		LPMP3INFP_GETVER mp3infp_GetVer;

		mp3infp_GetVer = (LPMP3INFP_GETVER )GetProcAddress( hMp3infpDll,"mp3infp_GetVer" );
		if( mp3infp_GetVer )
		{
			dwVer = mp3infp_GetVer();
			wsprintf( lpBuf, "%x", dwVer );
			//debug << "mp3infp.dll (" << lpBuf << ")ǂݍ݂܂" >> 0;
		}
		if( dwVer < 0x0253 || mp3infp_GetVer == NULL )
		{
			debug << "[G[]mp3infp.dll v2.53ȍ~Kvł" >> 0;
			FreeLibrary( hMp3infpDll );
			hMp3infpDll = NULL;
		}
	}
	else
	{
		debug << "[G[]mp3infp.dll̓ǂݍ݂Ɏs܂" >> 0;
	}
}

// fXgN^
CGlobalStruct::~CGlobalStruct()
{
	if( hMp3infpDll )
	{
		FreeLibrary( hMp3infpDll );
	}

	if( g.hThreadConvert )
	{
		WaitForSingleObject( g.hThreadConvert, INFINITE );
		CloseHandle( g.hThreadConvert );
	}

	if( g.hThreadRestore )
	{
		WaitForSingleObject( g.hThreadRestore, INFINITE );
		CloseHandle( g.hThreadRestore );
	}

	if( nExitCode == EXIT_CODE_NORMAL )
	{
		if( PathFileExists( sPathSetEnvTmp.c_str() ) ) DeleteFile( sPathSetEnvTmp.c_str() );
	}

	delete [] lpSoftDir;
}

//--------------------------------------------------------------------------
// CGlobalStruct_ini
//--------------------------------------------------------------------------
CGlobalStruct_ini::CGlobalStruct_ini()
{
	lpIniName = "ganmigi.ini";

	sIniPath = g.lpSoftDir;
	sIniPath += "\\";
	sIniPath += lpIniName;
	lpIniPath = sIniPath.c_str();
}

int CGlobalStruct_ini::WritePrivateProfileInt( LPCTSTR lpAppName, LPCTSTR lpKeyName, int nWriteData )
{
	wsprintf( lpWriteData, "%d", nWriteData );
	return WritePrivateProfileString( lpAppName, lpKeyName, lpWriteData, lpIniPath );
}

int CGlobalStruct_ini::IniLoad( const char *lpSoftDir )
{
	nMainWindowLeft = GetPrivateProfileInt( "main", "Left", ( GetSystemMetrics( SM_CXSCREEN ) - 80 * 4 ) / 2, lpIniPath );
	nMainWindowTop = GetPrivateProfileInt( "main", "Top", ( GetSystemMetrics( SM_CYSCREEN ) - 80 ) / 2, lpIniPath );

	nConvMode = GetPrivateProfileInt( "main", "ConvMode", 1, lpIniPath );
	nConvOption = GetPrivateProfileInt( "main", "ConvOption", 1, lpIniPath );
	bConvTag = GetPrivateProfileInt( "main", "ConvTag", true, lpIniPath ) != 0;
	bConvTagAgree = GetPrivateProfileInt( "main", "ConvTagAgree", true, lpIniPath ) != 0;

	bDispConvBeforeDialog = GetPrivateProfileInt( "main", "DispConvBeforeDialog", 1, lpIniPath ) != 0;
	bDispRestBeforeDialog = GetPrivateProfileInt( "main", "DispRestBeforeDialog", 1, lpIniPath ) != 0;
	bDispConvRestAfterDialog = GetPrivateProfileInt( "main", "DispConvRestAfterDialog", 0, lpIniPath ) != 0;

	bWndTopMost = GetPrivateProfileInt( "main", "WndTopMost", 0, lpIniPath ) != 0;

	nMaxNumLogData = GetPrivateProfileInt( "main", "MaxNumLogData", 256, lpIniPath );

	nInfoWindowLeft = GetPrivateProfileInt( "info", "Left", 0, lpIniPath );
	nInfoWindowTop = GetPrivateProfileInt( "info", "Top", 0, lpIniPath );
	nInfoWindowWidth = GetPrivateProfileInt( "info", "Width", DW_DEFAULT_WIDTH, lpIniPath );
	nInfoWindowHeight = GetPrivateProfileInt( "info", "Height", DW_DEFAULT_HEIGHT, lpIniPath );

	bInfoWindowShow = GetPrivateProfileInt( "info", "Show", 0, lpIniPath ) != 0;
	bInfoWindowNoUpdate = GetPrivateProfileInt( "info", "NoUpdate", 1, lpIniPath ) != 0;

	return 0;
}

int CGlobalStruct_ini::IniSave( const char *lpSoftDir )
{
	std::string sBuf;
	int nTmpConvOption = 1;
	int nTmpConvMode = 1;

	if( IsIconic( g.hWndMain ) == 0 )
	{
		WritePrivateProfileInt( "main", "Left", GetWindowPosX( g.hWndMain ) );
		WritePrivateProfileInt( "main", "Top", GetWindowPosY( g.hWndMain ) );
	}

	if( IsIconic( debug.GetDebugWindowHandle() ) == 0 )
	{
		WritePrivateProfileInt( "info", "Left", GetWindowPosX( debug.GetDebugWindowHandle() ) );
		WritePrivateProfileInt( "info", "Top", GetWindowPosY( debug.GetDebugWindowHandle() ) );
		WritePrivateProfileInt( "info", "Width", GetWindowWidth( debug.GetDebugWindowHandle() ) );
		WritePrivateProfileInt( "info", "Height", GetWindowHeight( debug.GetDebugWindowHandle() ) );
	}
	WritePrivateProfileInt( "info", "Show", GetMenuItemCheckState( g.hMenu, ID_MENU_INFO ) );

	if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_AUTO ) )
	{
		nTmpConvMode = 1;	
	}
	else if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_CONV ) )
	{
		nTmpConvMode = 2;	
	}
	else if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_RESTORE ) )
	{
		nTmpConvMode = 3;	
	}

	if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_ROMAN ) )
	{
		nTmpConvOption = 1;	
	}
	else if( GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_KATAKANA ) )
	{
		nTmpConvOption = 2;	
	}

	WritePrivateProfileInt( "main", "ConvMode", nTmpConvMode );
	WritePrivateProfileInt( "main", "ConvOption", nTmpConvOption );
	WritePrivateProfileInt( "main", "ConvTag", GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_TAG ) );
	WritePrivateProfileInt( "main", "ConvTag", GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_TAG ) );
	WritePrivateProfileInt( "main", "ConvTagAgree", GetMenuItemCheckState( g.hMenu, ID_MENU_CONV_TAG_AGREE ) );

	WritePrivateProfileInt( "main", "DispConvBeforeDialog", GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_CONV_BEFORE ) );
	WritePrivateProfileInt( "main", "DispRestBeforeDialog", GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_REST_BEFORE ) );
	WritePrivateProfileInt( "main", "DispConvRestAfterDialog", GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_AFTER ) );

	WritePrivateProfileInt( "main", "WndTopMost", GetMenuItemCheckState( g.hMenu, ID_MENU_WND_TOPMOST ) );

	WritePrivateProfileInt( "main", "MaxNumLogData", nMaxNumLogData );

	return 0;
};

//--------------------------------------------------------------------------
// CGlobalStruct_log
//--------------------------------------------------------------------------
CGlobalStruct_log::CGlobalStruct_log()
{
	lpLogName = "ganmigi.log";
	lpTmpLogName = "_ganmigi.log";

	sLogPath = g.lpSoftDir;
	sLogPath += "\\";
	sLogPath += lpLogName;
	bWriteDateFlag = true;

	lpLogPath = sLogPath.c_str();

	nIndex = GetPrivateProfileInt( "info", "nIndex", 0, lpLogPath );
}

int CGlobalStruct_log::WritePrivateProfileInt( LPCTSTR lpAppName, LPCTSTR lpKeyName, int nWriteData )
{
	wsprintf( lpWriteData, "%d", nWriteData );
	return WritePrivateProfileString( lpAppName, lpKeyName, lpWriteData, lpLogPath );
}

int CGlobalStruct_log::AddLogIndex( int n )
{
	nIndex += n;
	WritePrivateProfileInt( "info", "nIndex", nIndex );
	nCount = 0;
	bWriteDateFlag = true;
	return 0;
}

int CGlobalStruct_log::SubLogIndex( int n )
{
	nIndex -= n;
	WritePrivateProfileInt( "info", "nIndex", nIndex );
	return 0;
}

int CGlobalStruct_log::WriteLogData( std::string sFilePath, std::string sType, std::string sData )
{	// sDataFt@C͕ύX̃f[^A^O͕ύXÕf[^

	char lpIndex[32];
	char lpCount[32];
	char lpDate[32];
	SYSTEMTIME stDate;

	wsprintf( lpIndex, "No%d-Count", nIndex );
	wsprintf( lpCount, "%d", nCount + 1 );
	WritePrivateProfileString( "data", lpIndex, lpCount, lpLogPath );

	if( bWriteDateFlag )
	{
		GetLocalTime( &stDate );
		wsprintf( lpDate, "%dN%d%d%d%d%db", stDate.wYear, stDate.wMonth, stDate.wDay, stDate.wHour, stDate.wMinute, stDate.wSecond );
		wsprintf( lpIndex, "No%d-Date", nIndex );
		WritePrivateProfileString( "data", lpIndex, lpDate, lpLogPath );
		bWriteDateFlag = false;
	}

	replace( sData, "\r", "%__CR__%" );
	replace( sData, "\n", "%__LF__%" );

	wsprintf( lpIndex, "No%d-%d-Path", nIndex, nCount );
	WritePrivateProfileString( "data", lpIndex, sFilePath.c_str(), lpLogPath );
	wsprintf( lpIndex, "No%d-%d-Type", nIndex, nCount );
	WritePrivateProfileString( "data", lpIndex, sType.c_str(), g.log->lpLogPath );
	wsprintf( lpIndex, "No%d-%d-Data", nIndex, nCount );
	WritePrivateProfileString( "data", lpIndex, sData.c_str(), g.log->lpLogPath );

	nCount++;

	return 0;
}

bool CGlobalStruct_log::FileOpen( void )
{
	ShellExecute( NULL, NULL, "notepad", sLogPath.c_str(), NULL, SW_SHOWNORMAL );
	return true;
}

bool CGlobalStruct_log::Delete( void )
{
	SetCurrentDirectory( g.lpSoftDir );
	if( DeleteFile( lpLogName ) == TRUE )
	{
		nIndex = 0;
		return true;
	}
	else
	{
		return false;
	}
}

bool CGlobalStruct_log::IsRestoreData( void )
{
	char lpKeyName[32];

	for(;;)
	{
		if( nIndex == 0 )
		{
			return false;
		}

		wsprintf( lpKeyName, "No%d-Count", nIndex );
		// ݂ȂnIndexlZĂ
		nCount = GetPrivateProfileInt( "data", lpKeyName, 0, lpLogPath );
		if( nCount == 0 )
		{
			SubLogIndex();
		}
		else
		{
			return true;
		}
	}
}

bool CGlobalStruct_log::DeleteOldData( void )
{
	int nNumber = 0;
	int nDeleteNum;
	size_t nHyphenIndex;
	std::ifstream ifs;
	std::ofstream ofs;
	std::string sData;
	std::string sData2;
	std::string sNumber;

	nDeleteNum = nIndex - g.ini->nMaxNumLogData;
	if( nDeleteNum <= 0 ) return false;

	SetCurrentDirectory( g.lpSoftDir );

	CopyFile( lpLogName, lpTmpLogName, 0 );
	ifs.open( lpTmpLogName, std::ios::binary );	// binaryłȂƕsŒ~Ă܂
	if( ifs.fail() ) return false;
	ofs.open( lpLogName, std::ios::binary );
	if( ofs.fail() ) return false;
	for( int i = 0 ; ; i++ )
	{
		std::getline( ifs, sData, '\n' );
		if( ifs.eof() ) break;
		if( i >= 3 )
		{
			nHyphenIndex = sData.find( '-', 2 );
			sNumber = sData.substr( 2, nHyphenIndex - 2 );
			sData2 = sData.substr( nHyphenIndex, sData.size() - nHyphenIndex );
			nNumber = atoi( sNumber.c_str() );
			if( nNumber <= nDeleteNum ) continue;	// Âf[^폜
			nNumber -= nDeleteNum;
			ofs << "No" << nNumber << sData2 << std::endl;
		}
		else
		{
			ofs << sData << std::endl;
		}
	}
	ifs.close();
	ofs.close();
	SubLogIndex( nDeleteNum );
	DeleteFile( lpTmpLogName );

	return true;
}
int CGlobalStruct_log::GetRestoreDataInfo( std::string &sData )
{	// ߂l:nIndex, (Q)FO̕f[^

	char lpKeyName[32];
	int nCount;

	wsprintf( lpKeyName, "No%d-Count", nIndex );
	nCount = GetPrivateProfileInt( "data", lpKeyName, 0, lpLogPath );

	wsprintf( lpKeyName, "No%d-Date", nIndex );
	GetPrivateProfileString( "data", lpKeyName, "Error", g.lpBuf, g.nBufSize, lpLogPath );
	sData = g.lpBuf;
	sData += "\n\n";

	wsprintf( lpKeyName, "No%d-0-Path", nIndex );
	GetPrivateProfileString( "data", lpKeyName, "Error", g.lpBuf, g.nBufSize, lpLogPath );
	sData += "pXF";
	sData += g.lpBuf;
	sData += "\n\n";

	if( nCount >= 2 )
	{
		wsprintf( g.lpBuf, "   ...ȍ~%dӏ̕ύX", nCount );
		sData += g.lpBuf;
	}

	return nIndex;
}



UINT __stdcall ThreadRestore( LPVOID lpvData )
{
	int nIndex;
	int nCount;
	int i, j;
	int nRet;
	bool bWriteSuccess;
	char lpKeyName[32];
	char lpIndex[32];
	char lpCount[32];
	std::string sFileName, sFileDir;
	std::string sPath, sType, sData;
	std::string sWriteFilePath;
	std::string sPathTmp;
	static LPMP3INFP_LOAD mp3infp_Load = (LPMP3INFP_LOAD) GetProcAddress( g.hMp3infpDll, "mp3infp_Load");
	static LPMP3INFP_SAVE mp3infp_Save = (LPMP3INFP_SAVE) GetProcAddress( g.hMp3infpDll, "mp3infp_Save" );
	static LPMP3INFP_SETVALUE mp3infp_SetValue = (LPMP3INFP_SETVALUE) GetProcAddress( g.hMp3infpDll, "mp3infp_SetValue" );

	if( g.log->IsRestoreData() == false ) return 1;

	EnableWindow( g.hWndMain, false );

	nIndex = GetPrivateProfileInt( "info", "nIndex", 0, g.log->lpLogPath );
	wsprintf( lpKeyName, "No%d-Count", nIndex );
	nCount = GetPrivateProfileInt( "data", lpKeyName, 0, g.log->lpLogPath );
	for( i = nCount - 1, j = 0 ; i >= 0 ; i--, j++ )
	{
		bWriteSuccess = true;

		SetStatusBarProgress( j + 1, nCount );

		// NoX-X-Path
		wsprintf( lpKeyName, "No%d-%d-Path", nIndex, i );
		GetPrivateProfileString( "data", lpKeyName, "Error", g.lpBuf, g.nBufSize, g.log->lpLogPath );
		sPath = g.lpBuf;

		// NoX-X-Type
		wsprintf( lpKeyName, "No%d-%d-Type", nIndex, i );
		GetPrivateProfileString( "data", lpKeyName, "Error", g.lpBuf, g.nBufSize, g.log->lpLogPath );
		sType = g.lpBuf;

		// NoX-X-Data
		wsprintf( lpKeyName, "No%d-%d-Data", nIndex, i );
		GetPrivateProfileString( "data", lpKeyName, "Error", g.lpBuf, g.nBufSize, g.log->lpLogPath );
		sData = g.lpBuf;
		replace( sData, "%__CR__%", "\r" );
		replace( sData, "%__LF__%", "\n" );

		if( GetAsyncKeyState( VK_ESCAPE ) < 0 && sType == "FILE" )
		{
			if( IDYES == MessageBox( g.hWndMain, "rI܂H", g.lpSoftName, MB_APPDEF ) ) 
			{
				wsprintf( lpIndex, "No%d-Count", nIndex );
				wsprintf( lpCount, "%d", i + 1 );
				WritePrivateProfileString( "data", lpIndex, lpCount, g.log->lpLogPath );
				SetStatusBarProgress( 0, 0 );
				EnableWindow( g.hWndMain, true );
				return 1;
			}
		}

		if( sPathTmp != sPath )
		{
			debug >> 0;
			debug << "[ɖ߂]" << sPath >> 0;
			sPathTmp = sPath;
		}

		// ނƂɌɖ߂
		if( sType == "FILE" )
		{
			// t@Cɖ߂
			GetFileName( sPath, sFileName );
			GetFileDir( sPath, sFileDir );
			SetCurrentDirectory( sFileDir.c_str() );
			nRet = rename( sData.c_str(), sFileName.c_str() );
			if( nRet )
			{
				bWriteSuccess = false;
				debug << "[G[]l[ s" >> 0;
			}

			debug << "\tOF" << sData.c_str() << " -> " << sFileName.c_str() >> 0; 

		}
		else
		{
			// ^Oɖ߂
			if( mp3infp_Load( g.hWndMain, sPath.c_str() ) != ERROR_SUCCESS )
			{
				debug << "[G[]mp3infp_Load() s" >> 0;
				bWriteSuccess = false;
			}

			if( mp3infp_SetValue( sType.c_str(), sData.c_str()) != ERROR_SUCCESS )
			{
				debug << "[G[]^O̐ݒ mp3infp_SetValue() s" >> 0;
				bWriteSuccess = false;
			}

			if( mp3infp_Save( sPath.c_str() ) != ERROR_SUCCESS )
			{
				debug << "[G[]^O̕ۑ mp3infp_Save() s" >> 0;
				bWriteSuccess = false;
			}

			debug << "\t^OF(" << sType << ")" << sData.c_str() >> 0;
		}

		// G[ɕ\pX
		// 񃋁[vFILEłsFileDir + sDataAႦsPath
		if( i == nCount - 1 )
		{
			if( sType == "FILE" )
			{
				sWriteFilePath = sFileDir + sData;
			}
			else
			{
				sWriteFilePath = sPath;
			}
		}

		// G[
		if( bWriteSuccess == false )
		{
			int nRet;
			std::string sBuf;
			sBuf = "݁EO̕ύXɎs܂B\n";
			sBuf += "t@CpXF";
			sBuf += sWriteFilePath;
			sBuf += "\n\nt@CEtH_݂ȂAgpłȂA܂͓ǂݎpɂȂĂȂmFĂB\n\n(t@C̏ꍇ́Ãt@CdĂ\܂B\n ܂AdĂꍇAG[𖳎ď𑱍sƁAd̃t@CɃ^O񓙂ł܂ꂪ܂B)";
			nRet = MessageBox( g.hWndMain, sBuf.c_str(), g.lpSoftName, MB_ABORTRETRYIGNORE | MB_SETFOREGROUND | MB_TOPMOST );
			switch( nRet )
			{
			case IDIGNORE:
				break;
			case IDRETRY:
				i++;
				j--;
				continue;
			case IDABORT:
				wsprintf( lpIndex, "No%d-Count", nIndex );
				wsprintf( lpCount, "%d", i + 1 );
				WritePrivateProfileString( "data", lpIndex, lpCount, g.log->lpLogPath );
				SetStatusBarProgress( 0, 0 );
				EnableWindow( g.hWndMain, true );
				return 1;
			}
		}

		// INI폜
		wsprintf( lpKeyName, "No%d-%d-Path", nIndex, i );
		WritePrivateProfileString( "data", lpKeyName, NULL, g.log->lpLogPath );
		wsprintf( lpKeyName, "No%d-%d-Type", nIndex, i );
		WritePrivateProfileString( "data", lpKeyName, NULL, g.log->lpLogPath );
		wsprintf( lpKeyName, "No%d-%d-Data", nIndex, i );
		WritePrivateProfileString( "data", lpKeyName, NULL, g.log->lpLogPath );


	}

	// INI폜
	wsprintf( lpKeyName, "No%d-Count", nIndex );
	WritePrivateProfileString( "data", lpKeyName, NULL, g.log->lpLogPath );
	wsprintf( lpKeyName, "No%d-Date", nIndex );
	WritePrivateProfileString( "data", lpKeyName, NULL, g.log->lpLogPath );

	g.log->SubLogIndex();

	SetStatusBarProgress( 0, 0 );

	g.log->EnableRestoreBtnMenu();
	EnableWindow( g.hWndMain, true );

	if( GetMenuItemCheckState( g.hMenu, ID_MENU_DLG_AFTER ) )
	{
		MessageBox( g.hWndMain, "܂B", g.lpSoftName, MB_APPDEF_OK );
	}

	return 0;
}

int CGlobalStruct_log::RestoreData( void )
{
	static UINT dwThreadId;

	g.hThreadRestore = (HANDLE)_beginthreadex( NULL, 0, ThreadRestore, 0, 0, &dwThreadId );

	return 0;
}

void CGlobalStruct_log::EnableRestoreBtnMenu( void )
{
	EnableWindow( g.hWndRestoreBtn, IsRestoreData() );
	if( IsRestoreData() )
	{
		EnableMenuItem( g.hMenu, ID_MENU_RESTORE, MF_ENABLED );
	}
	else
	{
		EnableMenuItem( g.hMenu, ID_MENU_RESTORE, MF_GRAYED );
	}
}


#undef CGLOBALSTRUCT_BUFFER_SIZE


