
#ifndef __COMMON_H__
#define __COMMON_H__

#pragma warning( disable : 4786 )

#pragma comment(lib, "shlwapi.lib")

#define MB_APPDEF			( MB_YESNO | MB_SETFOREGROUND | MB_TOPMOST )
#define MB_APPDEF_OK		( MB_OK | MB_SETFOREGROUND | MB_TOPMOST )
#define MB_APPDEF_3BUTTON	( MB_YESNOCANCEL | MB_SETFOREGROUND | MB_TOPMOST )

#define DBG(msg) MessageBox( NULL, msg, "Debug", MB_OK )

#define EXIT_CODE_NORMAL			1
#define EXIT_CODE_SET_ENVIRONMENT	2
#define EXIT_CODE_ERROR				-1

#include <windows.h>
#include <fstream>
#include <stdlib.h>
#include <process.h>
#include <shlwapi.h>

#include "resource.h"
#include "CBaseDebug.h"
#include "CDebugMessage.h"
#include "mp3infp_ExportFunc.h"
#include "kakasi_func.h"
#include "replace.h"
#include "utility.h"

extern CDebugMessage debug;

class CGlobalStruct_ini;
class CGlobalStruct_log;

#define CGLOBALSTRUCT_BUFFER_SIZE 4096
//--------------------------------------------------------------------------
// CGlobalStruct
//--------------------------------------------------------------------------
class CGlobalStruct
{
public:
	char *lpSoftName;
	char *lpVer;
	char *lpSoftDir;
	char lpBuf[CGLOBALSTRUCT_BUFFER_SIZE];

	int nBufSize;
	int nVer;
	int nTmp;
	int nExitCode;

	HINSTANCE hInstance;
	HWND hWndMain;
	HMENU hMenu;
	HWND hWndStatusBar;
	HWND hWndOpenBtn, hWndRestoreBtn, hWndHelpBtn, hWndExitBtn;
	HANDLE hThreadConvert, hThreadRestore;
	HMODULE hMp3infpDll;

	std::string sPathSetEnvTmp;

	CGlobalStruct_ini *ini;
	CGlobalStruct_log *log;

public:
	CGlobalStruct();
	~CGlobalStruct();

};

extern CGlobalStruct g;

//--------------------------------------------------------------------------
// CGlobalStruct_ini
//--------------------------------------------------------------------------
class CGlobalStruct_ini
{
public:
	const char *lpIniName;
	const char *lpIniPath;
	int nMainWindowLeft;
	int nMainWindowTop;

	bool bDispConvBeforeDialog;
	bool bDispRestBeforeDialog;
	bool bDispConvRestAfterDialog;

	bool bWndTopMost;

	int nMaxNumLogData;

	int nInfoWindowLeft;
	int nInfoWindowTop;
	int nInfoWindowWidth;
	int nInfoWindowHeight;
	bool bInfoWindowShow;
	bool bInfoWindowNoUpdate;

	int nConvMode;
	int nConvOption;
	bool bConvTag;
	bool bConvTagAgree;					// t@CɑΉ^Ôݕ

	int IniLoad( const char *lpSoftDir );
	int IniSave( const char *lpSoftDir );

private:
	std::string sIniPath;
	char lpWriteData[1024];
	int WritePrivateProfileInt( LPCTSTR lpAppName, LPCTSTR lpKeyName, int nWriteData );

public:
	CGlobalStruct_ini();
	~CGlobalStruct_ini(){}

};
//--------------------------------------------------------------------------
// CGlobalStruct_log
//--------------------------------------------------------------------------
class CGlobalStruct_log
{
private:
	const char *lpLogPath;
	const char *lpLogName;
	const char *lpTmpLogName;
	int nIndex;
	int nCount;
	bool bWriteDateFlag;

public:
	int AddLogIndex( int n = 1 );
	int SubLogIndex( int n = 1 );
	int WriteLogData( std::string sFilePath, std::string sType, std::string sData );
	int RestoreData( void );
	bool FileOpen( void );
	bool Delete( void );
	bool IsRestoreData( void );
	bool DeleteOldData( void );
	int GetRestoreDataInfo( std::string &sData );
	void EnableRestoreBtnMenu( void );

	friend UINT __stdcall ThreadRestore( LPVOID lpvData );

private:
	std::string sLogPath;
	char lpWriteData[1024];
	int WritePrivateProfileInt( LPCTSTR lpAppName, LPCTSTR lpKeyName, int nWriteData );

public:
	CGlobalStruct_log();
	~CGlobalStruct_log(){}
};

#endif /* __COMMON_H__ */