
#ifndef __KAKASI_FUNC_H__
#define __KAKASI_FUNC_H__

#define KAKASI_FLAG_DEFAULT	0
#define KAKASI_FLAG_FILENAME	1

#define KAKASI_MODE_CONV	0
#define KAKASI_MODE_REST	1


#include "common.h"

#pragma warning(disable: 4996) // fopen -> fopen_s
#pragma comment(lib, "../kakasi.lib")
extern "C" {
#include "libkakasi.h"
}

char *Kakasi( int argc, char **argv, char *input );
char *KakasiRoman( char *input );
char *KakasiHankakuKatakana( char *input );
int KakasiSetEnvironmentDictPath( void );
int KakasiEraseExtFrontSpace( std::string &sInput );
std::string KakasiWrap( char *lpInput, std::string sFilePath, int nFlag = 0, int *nReturn = 0 );

class CConvDatabase 
{
private:
	const char *lpDatabaseName;
	const char *lpDatabasePath;
	std::string sDatabasePath;
	void ReplaceMark( std::string &sData );
	void ReplaceOrg( std::string &sData );
public:
	CConvDatabase( void );
	~CConvDatabase(){};
	int AddData( std::string sInput, std::string sData, std::string &sPath , int nFlag = KAKASI_FLAG_DEFAULT );
	std::string GetData( std::string sInput, std::string &sPath, int nFlag = KAKASI_FLAG_DEFAULT );
};

extern CConvDatabase ConvDatabase;

#endif /* __KAKASI_FUNC_H__ */
